/**
 * CSE 154 Summer 2019
 * Exam 1
 * Problem 5 Solution (JS/DOM)
 */
"use strict";
(function() {
  let total = 0;
  const TREATS = ["apples", "candycorn", "skittles", "smarties"];

  window.addEventListener("load", init);

  function init() {
    id("door").addEventListener("dblclick", findCandy);
    id("finish").addEventListener("click", showResults);
    id("reset").addEventListener("click", resetGame);
  }

  function resetGame() {
    this.classList.add("hidden");
    total = 0;
    id("results").textContent = ""; // can also hide
    id("candy-list").innerHTML = "";
  }

  function findCandy() {
    let rand = parseInt(Math.random() * TREATS.length);
    let treat = TREATS[rand];
    let randCount = Math.ceil(Math.random() * 10);
    total += randCount;
    let li = gen("li");
    li.textContent = "You got " + randCount + " ";
    let img = gen("img");
    img.src = treat + ".png";
    img.alt = treat;
    li.appendChild(img)
    if (id("candy-list").children.length == 0) {
      id("finish").classList.remove("hidden");
    }
    id("candy-list").appendChild(li);
  }

  function showResults() {
    id("results").textContent = "That's " + total + " treats over " + 
                                qsa("li").length + " visits!";
    id("reset").classList.remove("hidden");
    id("finish").classList.add("hidden");
  }

  /* -------------------- Helper Functions -------------------- */
  function id(idName) {
    return document.getElementById(idName);
  }

  function qsa(query) {
    return document.querySelectorAll(query);
  }

  function gen(tagName) {
    return document.createElement(tagName);
  }
})();
